package dk.nsp.xdscleanup.deprecated.stack.registry.submissionsets;

import dk.nsp.backgroundjob.stack.StackOperation;
import dk.nsp.xdscleanup.deprecated.factory.CleanupOperationsFactory;

import java.util.List;
import java.util.stream.Collectors;
import java.util.stream.Stream;

public class DanglingSubmissionSetsCleanupSupplier implements StackOperation {

    private final CleanupOperationsFactory cleanupOperationsFactory;

    public DanglingSubmissionSetsCleanupSupplier(CleanupOperationsFactory cleanupOperationsFactory) {
        this.cleanupOperationsFactory = cleanupOperationsFactory;
    }

    static final String[] charsAllowed = {"0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "a", "b", "c", "d", "e", "f"};
    //[0-9 og a-f. 3 tegn langt. 16^3 = 4096 muligheder]
    private static final List<String> PREFIXES = Stream.of(charsAllowed)
            .flatMap(i -> Stream.of(charsAllowed)
                    .flatMap(j -> Stream.of(charsAllowed)
                            .map(k -> i + j + k)))
            .collect(Collectors.toList());

    @Override
    public List<StackOperation> run() {
        return PREFIXES.stream().map(cleanupOperationsFactory::createDanglingSubmissionSetsBatchCleanupOperation).collect(Collectors.toList());
    }

}
