package dk.nsp.xdscleanup.stack.registry.deceased;

import dk.nsp.backgroundjob.stack.StackOperation;
import dk.nsp.xdscleanup.factory.CleanupOperationsFactory;
import org.junit.Before;
import org.junit.Test;
import org.mockito.Mockito;

import java.util.ArrayList;
import java.util.List;

import static org.junit.Assert.assertEquals;

public class DeceasedRegistryCleanupSupplierTest {

    private CleanupOperationsFactory cleanupOperationsFactory;
    private DeceasedRegistryCleanupSupplier deceasedRegistryCleanupSupplier;

    @Before
    public void setUp() {
        cleanupOperationsFactory = Mockito.mock(CleanupOperationsFactory.class);
        deceasedRegistryCleanupSupplier = new DeceasedRegistryCleanupSupplier(cleanupOperationsFactory);
    }

    @Test
    public void run_Returns10ExpectedSuppliers() {


        List<DeceasedRegistryPatientIdPrefixCleanupSupplier> prefixSuppliers = new ArrayList<>();
        for (int i = 0; i < 100; i++) {
            prefixSuppliers.add(Mockito.mock(DeceasedRegistryPatientIdPrefixCleanupSupplier.class));
        }

        Mockito.when(cleanupOperationsFactory.createDeceasedRegistryPatientIdPrefixCleanupSupplier(Mockito.anyString()))
                .thenReturn(prefixSuppliers.get(0))
                .thenReturn(prefixSuppliers.get(1))
                .thenReturn(prefixSuppliers.get(2))
                .thenReturn(prefixSuppliers.get(3))
                .thenReturn(prefixSuppliers.get(4))
                .thenReturn(prefixSuppliers.get(95))
                .thenReturn(prefixSuppliers.get(96))
                .thenReturn(prefixSuppliers.get(97))
                .thenReturn(prefixSuppliers.get(98))
                .thenReturn(prefixSuppliers.get(99));

        List<StackOperation> stackOperations = deceasedRegistryCleanupSupplier.run();
        assertEquals(100, stackOperations.size());

        Mockito.verify(cleanupOperationsFactory).createDeceasedRegistryPatientIdPrefixCleanupSupplier("00");
        Mockito.verify(cleanupOperationsFactory).createDeceasedRegistryPatientIdPrefixCleanupSupplier("01");
        Mockito.verify(cleanupOperationsFactory).createDeceasedRegistryPatientIdPrefixCleanupSupplier("02");
        Mockito.verify(cleanupOperationsFactory).createDeceasedRegistryPatientIdPrefixCleanupSupplier("03");
        Mockito.verify(cleanupOperationsFactory).createDeceasedRegistryPatientIdPrefixCleanupSupplier("04");
        Mockito.verify(cleanupOperationsFactory).createDeceasedRegistryPatientIdPrefixCleanupSupplier("95");
        Mockito.verify(cleanupOperationsFactory).createDeceasedRegistryPatientIdPrefixCleanupSupplier("96");
        Mockito.verify(cleanupOperationsFactory).createDeceasedRegistryPatientIdPrefixCleanupSupplier("97");
        Mockito.verify(cleanupOperationsFactory).createDeceasedRegistryPatientIdPrefixCleanupSupplier("98");
        Mockito.verify(cleanupOperationsFactory).createDeceasedRegistryPatientIdPrefixCleanupSupplier("99");
    }
}